/* 
os2-emtex-scm.cmd
SLaTeX version 2.4
(c) Dorai Sitaram, March 1995

Rexx script for invoking SLaTeX on your (La)TeX file.
This assumes you have OS/2, emTeX and scm.  Copy this
file to slatex.cmd and place in PATH.

Usage: slatex <(la)texfile>

Customization: modify the variable settings for
slatexfile, texcall and latexcall, using the comments
that follow.  There is no need to change anything else
after the "Don't change" line. */

'@echo off'

/* slatexfile contains the full pathname (including
double quotes) of the slatex.scm file generated during
SLaTeX configuration.  Change appropriately to suit
your setup. */

slatexfile = '"c:/scheme/slatex24/slatex.scm"'

/* texcall identifies how you call plain TeX on your
machine.  Change htex386 appropriately if using some
other, less powerful emTeX executable, e.g., texp.  If
you have your own .cmd file, say tex.cmd, that wraps a
call to the TeX executable, then texcall should be
'call tex'. */

texcall = 'htex386 ^&plain'

/* latexcall identifies how you call LaTeX on your
machine. Change htex386 appropriately as for texcall.
Change &latex to &lplain if still using LaTeX 2.09. */

latexcall = 'htex386 ^&latex'

/* Don't change following unless you're a Rexx wiz. */

call rxfuncadd 'sysloadfuncs', 'rexxutil', 'sysloadfuncs'
call sysloadfuncs
parse arg slatexee .

call lineout 'slatex.jnk', '(load '
call lineout 'slatex.jnk', slatexfile
call lineout 'slatex.jnk', ')'
call lineout 'slatex.jnk', '(set! SLaTeX.*texinputs* (getenv "TEXINPUT"))'
call lineout 'slatex.jnk', '(SLaTeX.process-main-tex-file (getenv "SLATEXEE"))'
call lineout 'slatex.jnk', '(SLaTeX.exit-scheme)'
call lineout 'slatex.jnk'
call setlocal
rawtexinput = value('texinput', , 'os2environment')
realtexinput = ''
do while rawtexinput \= ''
  parse var rawtexinput eachtexdir ';' rawtexinput
  n = length(eachtexdir)
  doublebang = lastpos('!!', eachtexdir)
  if n > 1 & doublebang = n - 1 then do
    d = substr(eachtexdir, 1, doublebang - 1)
    realtexinput = realtexinput';'d
    call sysfiletree d'\*', 'ff', 'dso'
    do i = 1 to ff.0
      realtexinput = realtexinput';'ff.i
    end
    iterate
    end
  singlebang = lastpos('!', eachtexdir)
  if singlebang = n then do
    d = substr(eachtexdir, 1, singlebang - 1)
    realtexinput = realtexinput';'d
    call sysfiletree d'\*', 'ff', 'fo'
    do i = 1 to ff.0
      realtexinput = realtexinput';'ff.i
    end
    iterate
    end
  realtexinput = realtexinput';'eachtexdir
end
call value 'texinput', realtexinput, 'os2environment'
call value 'slatexee', slatexee, 'os2environment'
'scm slatex.jnk'
call endlocal
'del slatex.jnk'
'attrib +h .z*.tex'
if stream('pltexchk.jnk', 'c', 'query exist') \= '' then do
  texcall slatexee
  'del pltexchk.jnk'
  end
else
  latexcall slatexee  



